# SeqMonk
SeqMonk is a desktop application for the visualisation and analysis of large mapped genomic datasets, normally coming from high througput sequencing.

![SeqMonk Screenshot](http://www.bioinformatics.babraham.ac.uk/projects/seqmonk/seqmonk.png)

It is useful for the analysis of any experiment type which produces sets of mapped positions relating to a reference genome.  This would include (but is not limited to)

* RNA-Seq
* ChIP-Seq
* BS-Seq
* HiC

This project page contains the source code for the application and is useful only to people wanting to develop new functionality in SeqMonk.  If you just want to run the program then you want to go to the [**project web page**](http://www.bioinformatics.babraham.ac.uk/projects/seqmonk/) where you can download the normal desktop pacakges for Windows, OSX and Linux.

# Installation Instructions

# Windows

1. Install [R](https://cran.r-project.org/bin/windows/base/)
2. Download the latest SeqMonk windows zip file from the [project website](http://www.bioinformatics.babraham.ac.uk/projects/download.html#seqmonk)
3. Unzip the contents somewhere on your machine
4. Double click on seqmonk.exe

# OSX

1. Install [R](https://cran.r-project.org/bin/macosx/)
2. Install the [R OSX toolchain](https://github.com/rmacoslib/r-macos-rtools) to allow you to compile all of the packages you will need
3. Download the latest SeqMonk DMG file from the [project website](http://www.bioinformatics.babraham.ac.uk/projects/download.html#seqmonk)
4. Open the DMG file and drag the icon to somewhere on your computer (normally the applications folder).
5. Double click the icon.  If you get a warning about an unsigned application then right-click on the icon and select "Open". You should then be able to allow the application to run.  This warning will only appear once per-machine.

# Linux

1. Install [R](https://cran.r-project.org/bin/linux/)
2. Install a development environment (Ubuntu: sudo apt install build-essential  Centos: sudo yum groupinstall "Development tools")
3. Install the xml2-dev library (Ubuntu: sudo apt install libxml2-dev  Centos: sudo yum install libxml2-devel)
4. Download the latest SeqMonk linux tar.gz file from the [project website](http://www.bioinformatics.babraham.ac.uk/projects/download.html#seqmonk)
5. Untar the contents somewhere on your machine
6. Use cd to move to the directory you just created
7. Run ./seqmonk

SeqMonk - A Mapped Sequence Analysis tool
---------------------------------------

SeqMonk is a tool for viewing and analysing mapped sequence data.  It
was initially written to cope with remapping experiment data from
next generation sequencers, but could be applied to any dataset
consisting of a series of mapped genomic regions.  The program allows
you to visualise the positions of your mapped regions against an
annotated genome and to quantify the data in order to make comparisons
between data sets.

SeqMonk is a cross-platform application, written in java.  In theory it
should run on any platform which has a suitable java runtime environment.
It requires at least java 8 (v1.8) and should run on any of the major
operating systems.

If you have any comments about SeqMonk we would like to hear them.  You
can either enter them in our bug tracking system at:

https://github.com/s-andrews/seqmonk/issues/

..or send them directly to simon.andrews@babraham.ac.uk.

This folder contains the source for the OSX Rust launcher
which is required so that SeqMonk can take disk permissions
on OSX.

It's a Cargo project so you can use that to build it, however 
by default the resulting binary will depend on the version of
OSX which you used to compile it, which is too restrictive.
To get around this you first need to do:

export MACOSX_DEPLOYMENT_TARGET=10.8

..then..

cargo build --release

..to compile it.

setwd("%%WORKING%%")

# Load Limma
library("limma")

# Read in the full count table from SeqMonk
just.raw.counts <- read.delim("counts.txt",quote="",row.names=1, check.names=FALSE)

# Make up a condition table

conditions <- as.factor(gsub("-.*","",colnames(just.raw.counts)))

design <- data.frame(All=rep(1,ncol(just.raw.counts)))

sapply(
  levels(conditions),
  function(x) {
    design[[x]]<<-rep(0,ncol(just.raw.counts))
    design[[x]][startsWith(colnames(just.raw.counts),x)] <<- 1
  }
 )

design[,-1] -> design

makeContrasts(%%CONTRASTS%% levels=design) -> contrast.matrix


# Perform the analysis.
lmFit(just.raw.counts,design) -> efit

contrasts.fit(efit,contrast.matrix) -> fit

eBayes(fit,trend=TRUE) -> fit

topTable(fit,number=nrow(just.raw.counts),adjust.method="BH") -> all.hits

# Select significant hits
all.hits[all.hits$%%CORRECTED%% <= %%PVALUE%%,] -> significant.results

# Write the hit names to a file
write.table(significant.results,file="hits.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

setwd("%%WORKING%%")

# Read in the full count table from SeqMonk
just.raw.counts <- read.delim("counts.txt",quote="",row.names=1)

# Make up a condition table
group <- c(%%CONDITIONS%%)


library("edgeR")

edger.data <- DGEList(counts=just.raw.counts,group=group)

edger.data <- calcNormFactors(edger.data)
edger.data <- estimateCommonDisp(edger.data)
edger.data <- estimateTagwiseDisp(edger.data)
test.results <- exactTest(edger.data)

corrected.results <- topTags(test.results,n=nrow(test.results$table))

write.table(corrected.results$table[corrected.results$table$%%CORRECTED%% <= %%PVALUE%%,],file="hits.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

setwd("%%WORKING%%")

list.files(pattern = "data_chr") -> data.files

# Do a sanity check that there is data in every file
# and remove any empty ones

data.files[sapply(data.files,function(x)nrow(read.delim(x,nrows = 2))==2)] -> data.files

process.file <- function(x) {
  
  print (paste("Processing ",x))
  
  read.delim(x,colClasses = c("character", "factor", "factor", "factor", "numeric")) -> data
  
  return(do.call("rbind",(by(data,data$id,logistic.regression))))
  
}

logistic.regression <- function (x) {
  
  fit <- glm(state ~ group+replicate, weights = count, data = x, family = binomial)
  
  rbind(by(x,x[,c("group","replicate")],function(y)y$count[1]/sum(y$count)*100)) -> percentages


  return (c(
    (coef(summary(fit))["groupto", "Pr(>|z|)"]),
    mean(percentages[1,] - percentages[2,],na.rm=TRUE))
  );
  
}

## WARNING ##
## THIS BIT IS SLOW ##

## We do around 250 models/sec ##

as.data.frame(do.call("rbind",lapply(data.files,process.file))) -> regression.results

colnames(regression.results) <- c("P-value","Difference")

p.adjust(regression.results$`P-value`,method = "fdr", n=%%CORRECTCOUNT%%) -> regression.results$FDR

if (%%MULTITEST%%) {
  regression.results[regression.results$FDR < %%PVALUE%%,] -> regression.results
}else {
  regression.results[regression.results$`P-value` < %%PVALUE%%,] -> regression.results
}

# Write the hit names to a file
write.table(regression.results,file="hits.txt",row.names=TRUE,quote=FALSE,sep="\t")

setwd("%%WORKING%%")

# Read in the quantitations from SeqMonk. We only need the first column
seqmonk.quantitation <- read.delim("quantitation.txt")[[1]]

# Load the segmentation library
library(fastseg)

# Perform the analysis.
fastseg(seqmonk.quantitation,type=%%GLOBAL%%, alpha=%%ALPHA%%) -> segments

# Write the segments to a file
write.table(segments,file="segments.txt",row.names=FALSE,quote=FALSE,sep="\t")

setwd("%%WORKING%%")

library(Rtsne)

# Read in the full data table from SeqMonk
tsne.data <- read.delim("data.txt",quote="",header=FALSE)

Rtsne(t(tsne.data), perplexity=%%PERPLEXITY%%, max_iter=%%ITERATIONS%%, verbose=TRUE) -> tsne.results

# Write the TSNE data to a file
write.table(tsne.results$Y,file="tsne_data.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

# We need to specify a repository to use.  If the user has one set
# in their preferences then we'll use that.  If not then we'll use
# the generic cloud R URL.

repository = getOption("CRAN","http://cloud.r-project.org")


# We want to force windows and mac users to use binary distributions
# to do this we need to set the type value for install.packages. We 
# need to look at the OS to figure out what this should be

if (Sys.info()["sysname"] == "Windows") {
  options(install.packages.check.source = "no")
  options(install.packages.compile.from.source = "never")
}

if (Sys.info()["sysname"] == "Darwin") {
  options(install.packages.check.source = "no")
  options(install.packages.compile.from.source = "never")
}

install.cran <- function (package) {
  
  # First test if it's here already
  if (!package %in% rownames(installed.packages())) {
    install.packages(package, repos=repository)
  }else {
    print(paste0(package," is already installed"))
  }
  
}

install.bioconductor <- function (package) {
  
  # First test if it's here already
  if (!package %in% rownames(installed.packages())) {
    BiocManager::install(package, update=FALSE)
  }else {
    print(paste0(package," is already installed"))
  }
  
}



# We need to work around a bug in the latest bioconductor/R combination
install.cran("data.table")

# EdgeR also has a buggy manifest which doesn't say it needs the 
# statmod package, so we get that too.
install.cran("statmod")


install.cran("Rtsne")



# We used to support both the old and new versions of bioconductor
# but since the R package repository for versions < 3.6 has been 
# broken for months we're now going to insist on R 3.6 and therefore
# the newer version of Bioconductor using BiocManager.

  
install.cran("BiocManager")
install.bioconductor("DESeq2")
install.bioconductor("edgeR")
install.bioconductor("fastseg")

# NB we don't need to explicitly install limma as it's a dependency
# of EdgeR.  If this changes then we'd need to add it.

# If these think they installed OK we now need to test them

library("DESeq2")
library("edgeR")
library("Rtsne")
library("limma")
library("statmod")
library("fastseg")

setwd("%%WORKING%%")

# Read in the full count table from SeqMonk
just.raw.counts <- read.delim("counts.txt",quote="",row.names=1)

# Make up a condition table
column.data <- data.frame(%%CONDITIONS%%)

rownames(column.data) <- colnames(just.raw.counts)

# Load DESeq2
library("DESeq2")

# Make a DESeq data set from the counts and the design and specify which factors in
# the design to test
count.data.set <- DESeqDataSetFromMatrix(countData=just.raw.counts, colData=column.data,design= ~ %%DESIGN%%)

# Perform the analysis.
if(length(levels(column.data$source))>2) {
  count.data.set <- DESeq(count.data.set, test="LRT", full= ~%%DESIGN%%, reduced= ~%%REDUCED%%)
}else {
  count.data.set <- DESeq(count.data.set)
}

# Retrieve the full set of results.
binomial.result <- results(count.data.set,independentFiltering=%%INDEPENDENT%%)

if(length(levels(column.data$source))==2) {
	shrunk.result <- lfcShrink(count.data.set,coef="source_group1_vs_group0",independentFiltering=%%INDEPENDENT%%,type="normal")
	binomial.result$shrunkLog2FoldChange <- shrunk.result$log2FoldChange
}

# Remove unmeasured results
na.omit(binomial.result) -> binomial.result

# Select significant hits
binomial.result[binomial.result$%%CORRECTED%% <= %%PVALUE%%,] -> significant.results

# Order the hits by p-value
significant.results[order(significant.results$%%CORRECTED%%),] -> significant.results

# Write the hit names to a file
write.table(significant.results,file="hits.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

setwd("%%WORKING%%")

# Read in the full data table from SeqMonk
pca.data <- read.delim("data.txt",quote="",header=FALSE)

prcomp(t(pca.data)) -> pca.results

# Write the PC data to a file
write.table(pca.results$x,file="pca_data.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

# Write the variance data to a file
write.table((pca.results$sdev^2),file="variance_data.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

# Write out the weightings to a file
write.table(pca.results$rotation,file="pca_weights.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

setwd("%%WORKING%%")

# Read in the full count table from SeqMonk
just.raw.counts <- read.delim("counts.txt",quote="",row.names=1)

# Make up a condition table
group <- c(%%CONDITIONS%%)


library("edgeR")

edger.data <- DGEList(counts=just.raw.counts,group=group)

totalCount <- colMeans(matrix(edger.data$samples$lib.size, nrow=2, ncol=length(group)/2))

edger.data$samples$lib.size <- rep(totalCount, each=2)

samples <- unique(gsub("_unmeth","",gsub("_meth","",colnames(just.raw.counts))))

design <- data.frame(Int=rep(1,length(group)))

for (index in 2:length(samples)) {
  cbind(design,c(rep(0,(index-1)*2),1,1,rep(0,(length(samples)-index)*2))) -> design
}

design <- cbind(design,rep(c(1,0),length(samples)))

design <- cbind(design,c(
  rep(c(0,0),length(grep("from",samples))),
  rep(c(1,0),length(grep("to",samples))))
)

colnames(design) <- c("Int",samples[2:length(samples)],"Me1","Me2")


edger.data <- estimateDisp(edger.data, design=design, trend="none", robust=TRUE)

fit <- glmFit(edger.data, design)

contr <- makeContrasts(BvsL=Me2, levels=design)

lrt.results <- glmLRT(fit, contrast=contr)

corrected.results <- topTags(lrt.results,n=nrow(lrt.results$table))

write.table(corrected.results$table[corrected.results$table$%%CORRECTED%% < %%PVALUE%%,],file="hits.txt",row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")

#!/bin/bash

# This script is only really designed to work on the Babraham
# build system.  It takes the current version of seqmonk and
# builds the release files for it ready for upload to the web 
# site.
#
# For the OSX release we need a couple of additional packages
# from brew, specifically 
#
# brew install gnu-tar
# brew install create-dmg

VERSION=$1

if test -z $VERSION
then
	echo "VERSION must be passed"
	exit 1
fi

cd ~/Data

# Do windows first
echo "Copying windows version"
cp -r ~/git/SeqMonk/bin ./SeqMonk

echo "Copying windows jre"
cp -r jre-windows64 SeqMonk/jre

echo "Removing unwanted bits"
# We get a warning from trying to delete . and .. but that's OK
rm -rf SeqMonk/.* SeqMonk/Windows SeqMonk/build.xml

echo "Compressing into zip file"
zip -rq seqmonk_v${VERSION}_windows64.zip SeqMonk

echo "Cleaning up"
rm -rf SeqMonk



# Do linux next
echo "Copying linux version"
cp -r ~/git/SeqMonk/bin ./SeqMonk

echo "Copying linux jre"
cp -r jre-linux64 SeqMonk/jre

echo "Removing unwanted bits"
# We get a warning from trying to delete . and .. but that's OK
rm -rf SeqMonk/.* SeqMonk/Windows SeqMonk/build.xml

echo "Compressing into tar file"
# We installed gnu-tar (gtar) from brew to get a version 
# which doesn't give us warning when we uncompress on linux
gtar -czf seqmonk_v${VERSION}_linux64.tar.gz SeqMonk

echo "Cleaning up"
rm -rf SeqMonk


# Finally OSX
echo "Cleaning OSX app"
rm -rf SeqMonk.app/Contents/MacOS/*

echo "Copying OSX version"
cp -r ~/git/SeqMonk/bin/* ./SeqMonk.app/Contents/MacOS/

echo "Copying osx jre"
cp -r jre-osx ./SeqMonk.app/Contents/MacOS/jre

echo "Removing unwanted bits"
# We get a warning from trying to delete . and .. but that's OK
rm -rf ./SeqMonk.app/Contents/MacOS/.* ./SeqMonk.app/Contents/MacOS/Windows ./SeqMonk.app/Contents/MacOS/build.xml

echo "Fixing Plist file"
# Put the new version in the Plist file
sed "s/%%VERSION%%/${VERSION}/" ./SeqMonk.app/Contents/Info.plist.template > ./SeqMonk.app/Contents/Info.plist


# Put the app into a directory called SeqMonk
echo "Copying app"
mkdir SeqMonk
cp -r SeqMonk.app SeqMonk/

# Make the pretty dmg
echo "Compressing into dmg file"
create-dmg \
--volname "SeqMonk" \
--volicon "/Users/andrewss/git/SeqMonk/uk/ac/babraham/SeqMonk/Resources/seqmonk.icns" \
--background "/Users/andrewss/git/SeqMonk/uk/ac/babraham/SeqMonk/Resources/monk_dmg_background.png" \
--window-pos 200 120 \
--window-size 800 400 \
--icon-size 100 \
--icon "SeqMonk.app" 200 160 \
--app-drop-link 600 155 \
seqmonk_v${VERSION}_osx64.dmg \
SeqMonk

# Clean up the folder
rm -rf SeqMonk
